Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bugzilla DB migration completed. Please report issues to Infra team via email via infra@gentoo.org or IRC
Bug 715394 - media-gfx/inkscape-0.92.4-r2 fails to build with dev-cpp/glibmm-2.62
Summary: media-gfx/inkscape-0.92.4-r2 fails to build with dev-cpp/glibmm-2.62
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Mikle Kolyada
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2020-03-30 07:47 UTC by Pacho Ramos
Modified: 2020-04-25 13:24 UTC (History)
4 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
build.log.gz (inkscape-0.92.4-r2:20200330-074027.log.gz,44.65 KB, application/gzip)
2020-03-30 07:47 UTC, Pacho Ramos
Details
glibmm-enable-deprecated-api.patch (glibmm-enable-deprecated-api.patch,561 bytes, patch)
2020-04-03 19:37 UTC, Matt Whitlock
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Pacho Ramos gentoo-dev 2020-03-30 07:47:02 UTC
Created attachment 627162 [details]
build.log.gz

Maybe we will need to remember to stabilize a newer version in the future when needing to stabilize newer glibmm
extension/timer.cpp: In member function 'bool Inkscape::Extension::ExpirationTimer::expired() const':
extension/timer.cpp:129:13: error: 'struct Glib::TimeVal' has no member named 'assign_current_time'
  129 |     current.assign_current_time();
      |             ^~~~~~~~~~~~~~~~~~~
extension/timer.cpp:130:23: error: no match for 'operator<' (operand types are 'const Glib::TimeVal' and 'Glib::TimeVal')
  130 |     return expiration < current;
      |            ~~~~~~~~~~ ^ ~~~~~~~
      |            |            |
      |            |            Glib::TimeVal
      |            const Glib::TimeVal
In file included from /usr/include/glibmm-2.4/glibmm/timeval.h:23,
                 from /usr/include/glibmm-2.4/glibmm/main.h:22,
                 from extension/timer.cpp:13:
/usr/include/glibmm-2.4/glibmm/ustring.h:1128:1: note: candidate: 'bool Glib::operator<(const const_iterator&, const const_iterator&)'
 1128 | operator<(const Glib::ustring::const_iterator& lhs, const Glib::ustring::const_iterator& rhs)
      | ^~~~~~~~
/usr/include/glibmm-2.4/glibmm/ustring.h:1128:48: note:   no known conversion for argument 1 from 'const Glib::TimeVal' to 'const const_iterator&' {aka 'const Glib::ustring_Iterator<__gnu_cxx::__normal_iterator<const char*, std::__cxx11::basic_string<char> > >&'}
 1128 | operator<(const Glib::ustring::const_iterator& lhs, const Glib::ustring::const_iterator& rhs)
      |           ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~^~~
/usr/include/glibmm-2.4/glibmm/ustring.h:1730:1: note: candidate: 'bool Glib::operator<(const Glib::ustring&, const Glib::ustring&)'
 1730 | operator<(const ustring& lhs, const ustring& rhs)
      | ^~~~~~~~
/usr/include/glibmm-2.4/glibmm/ustring.h:1730:26: note:   no known conversion for argument 1 from 'const Glib::TimeVal' to 'const Glib::ustring&'
 1730 | operator<(const ustring& lhs, const ustring& rhs)
      |           ~~~~~~~~~~~~~~~^~~
/usr/include/glibmm-2.4/glibmm/ustring.h:1737:1: note: candidate: 'bool Glib::operator<(const Glib::ustring&, const char*)'
 1737 | operator<(const ustring& lhs, const char* rhs)
      | ^~~~~~~~
/usr/include/glibmm-2.4/glibmm/ustring.h:1737:26: note:   no known conversion for argument 1 from 'const Glib::TimeVal' to 'const Glib::ustring&'
 1737 | operator<(const ustring& lhs, const char* rhs)
      |           ~~~~~~~~~~~~~~~^~~
/usr/include/glibmm-2.4/glibmm/ustring.h:1744:1: note: candidate: 'bool Glib::operator<(const char*, const Glib::ustring&)'
 1744 | operator<(const char* lhs, const ustring& rhs)
      | ^~~~~~~~
/usr/include/glibmm-2.4/glibmm/ustring.h:1744:23: note:   no known conversion for argument 1 from 'const Glib::TimeVal' to 'const char*'
 1744 | operator<(const char* lhs, const ustring& rhs)
      |           ~~~~~~~~~~~~^~~
make[3]: *** [Makefile:9110: extension/timer.o] Error 1
make[3]: Leaving directory '/var/tmp/portage/media-gfx/inkscape-0.92.4-r2/work/inkscape-0.92.4/src'
make[2]: *** [Makefile:5976: all] Error 2
make[2]: Leaving directory '/var/tmp/portage/media-gfx/inkscape-0.92.4-r2/work/inkscape-0.92.4/src'
make[1]: *** [Makefile:1472: all-recursive] Error 1
make[1]: Leaving directory '/var/tmp/portage/media-gfx/inkscape-0.92.4-r2/work/inkscape-0.92.4'
make: *** [Makefile:1128: all] Error 2
Comment 1 Pacho Ramos gentoo-dev 2020-03-30 07:47:36 UTC
Portage 2.3.96 (python 3.8.2-final-0, default/linux/amd64/17.0/desktop/gnome/systemd, gcc-9.2.0, glibc-2.29-r7, 5.5.8-gentoo x86_64)
=================================================================
System uname: Linux-5.5.8-gentoo-x86_64-Intel-R-_Core-TM-_i7-7700HQ_CPU_@_2.80GHz-with-glibc2.4
KiB Mem:    16104372 total,   1967696 free
KiB Swap:    5240828 total,   5240316 free
Timestamp of repository gentoo: Sun, 29 Mar 2020 18:30:01 +0000
Head commit of repository gentoo: 3e95e365e2080ae72c9160a725846eb8d71e416a
sh bash 4.4_p23-r1
ld GNU ld (Gentoo 2.33.1 p2) 2.33.1
ccache version 3.7.9 [enabled]
app-shells/bash:          4.4_p23-r1::gentoo
dev-java/java-config:     2.2.0-r4::gentoo
dev-lang/perl:            5.30.1::gentoo
dev-lang/python:          2.7.17-r1::gentoo, 3.5.7::gentoo, 3.6.10::gentoo, 3.7.7::gentoo, 3.8.2::gentoo
dev-util/ccache:          3.7.9::gentoo
dev-util/cmake:           3.16.5::gentoo
dev-util/pkgconfig:       0.29.2::gentoo
sys-apps/baselayout:      2.6-r1::gentoo
sys-apps/openrc:          0.42.1::gentoo
sys-apps/sandbox:         2.13::gentoo
sys-devel/autoconf:       2.13-r1::gentoo, 2.69-r4::gentoo
sys-devel/automake:       1.11.6-r3::gentoo, 1.16.1-r2::gentoo
sys-devel/binutils:       2.33.1-r1::gentoo
sys-devel/gcc:            8.3.0-r3::gentoo, 9.2.0-r2::gentoo
sys-devel/gcc-config:     2.2.1::gentoo
sys-devel/libtool:        2.4.6-r6::gentoo
sys-devel/make:           4.2.1-r4::gentoo
sys-kernel/linux-headers: 5.4::gentoo (virtual/os-headers)
sys-libs/glibc:           2.29-r7::gentoo
Repositories:

gentoo
    location: /usr/portage
    sync-type: rsync
    sync-uri: rsync://rsync.gentoo.org/gentoo-portage
    priority: -1000
    sync-rsync-verify-max-age: 24
    sync-rsync-verify-metamanifest: no
    sync-rsync-extra-opts: 
    sync-rsync-verify-jobs: 1

x-portage
    location: /usr/local/portage
    masters: gentoo
    priority: 0

maggu2810-overlay
    location: /hdd/portage/local/layman/maggu2810-overlay
    masters: gentoo
    priority: 50

science
    location: /hdd/portage/local/layman/science
    masters: gentoo
    priority: 50

torbrowser
    location: /hdd/portage/local/layman/torbrowser
    masters: gentoo
    priority: 50

ACCEPT_KEYWORDS="amd64"
ACCEPT_LICENSE="*"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-O2 -pipe -march=native -fno-stack-protector"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/lib64/libreoffice/program/sofficerc /usr/share/config /usr/share/gnupg/qualified.txt"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/dconf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo /etc/texmf/language.dat.d /etc/texmf/language.def.d /etc/texmf/updmap.d /etc/texmf/web2c"
CXXFLAGS="-O2 -pipe -march=native -fno-stack-protector"
DISTDIR="/hdd/distfiles"
EMERGE_DEFAULT_OPTS="--quiet-build=n --autounmask-write --keep-going --autounmask=y --with-test-deps --backtrack=500"
ENV_UNSET="DBUS_SESSION_BUS_ADDRESS DISPLAY GOBIN PERL5LIB PERL5OPT PERLPREFIX PERL_CORE PERL_MB_OPT PERL_MM_OPT XAUTHORITY XDG_CACHE_HOME XDG_CONFIG_HOME XDG_DATA_HOME XDG_RUNTIME_DIR"
FCFLAGS="-O2 -pipe"
FEATURES="assume-digests binpkg-docompress binpkg-dostrip binpkg-logs ccache cgroup compress-build-logs compressdebug config-protect-if-modified distlocks ebuild-locks fixlafiles ipc-sandbox merge-sync multilib-strict network-sandbox news parallel-fetch parallel-install pid-sandbox preserve-libs protect-owned qa-unresolved-soname-deps sandbox sfperms sign split-log strict unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv usersandbox usersync xattr"
FFLAGS="-O2 -pipe"
GENTOO_MIRRORS="http://distfiles.gentoo.org"
LANG="es_ES.utf8"
LDFLAGS="-Wl,-O1 -Wl,--as-needed -Wl,--hash-style=gnu"
LINGUAS="es es_ES en en_US fr fr_FR"
MAKEOPTS="-j9"
PKGDIR="/hdd/packages"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --omit-dir-times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages --exclude=/.git"
PORTAGE_TMPDIR="/var/tmp"
USE="7z 7zip X a52 aac acl acpi alsa amd64 applet archive aribsub avahi avx avx256 bash-completion berkdb bluetooth bluray branding btrfs bzip2 cairo ccache cdda cddb cdr chm chrome chromecast chromium cli colord crypt cuda cups cvs dbus dell djvu dot dri dts dvd dvdr dvi ebook eds emboss enchant encode epub equalizer ethernet evince evo excel exif fat ffmpeg firefox flac flash fortran fuse games gdbm gdk-pixbuf gdm gedit gif gimp git gnome gnome-keyring gnome-online-accounts gnome-shell gnumeric google googledrive gphoto2 gpm grammar gromacs gstreamer gtk gtk3 gtkstyle gui heif hfs html http hwaccel ico icons iconv icu inkscape inotify introspection ios ipod irc iso jabber jpeg jumbo-build kate kpathsea latex lcms ldap libass libdrm libnotify librtmp libsecret libtirpc libv4l libvisual lm_sensors lyx lz4 lzma lzo mad math matroska media mediaplayer metric microdns mms mmx mmxext mng mobi monolithic-build mp3 mp4 mpeg mtp multilib music musicbrainz nautilus ncurses network network-cron networkmanager nls nptl ntfs ntp numa nvidia nvme oauth offensive ogg opengl openmp openvpn optimized-qmake opus pam pango pch pdf pdfimport pipelight png policykit postscript ppapi ppds pptx projectm proprietary-codecs pstricks publishers pulseaudio qt5 rar raw rdp readline reiserfs rtf rtmp scanner sdl seccomp sendto sftp smp sna snmp sox spell split-usr squashfs sse sse2 sse3 sse4 sse4_1 ssl ssse3 startup-notification subtitles svg systemd t1lib tcpd theora thesaurus threads tiff totem tracker truetype udev udisks uefi unicode update_drivedb upnp upnp-av upower usb user-session v4l vaapi vala vcd vdpau vector-icons vimeo visio vlc vnc vorbis vpx webp wifi wma wmf wpg wxwidgets x264 x265 xattr xcb xfs xml xmp xmpp xpm xps xv xvid xz youtube zeroconf zfs zlib zstd" ABI_X86="64" ADA_TARGET="gnat_2018" ALSA_CARDS="hda-intel" APACHE2_MODULES="authn_core authz_core socache_shmcb unixd actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" CALLIGRA_FEATURES="karbon sheets words" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" CPU_FLAGS_X86="aes avx avx2 f16c fma3 mmx mmxext pclmul popcnt sse sse2 sse3 sse4_1 sse4_2 ssse3" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock greis isync itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf skytraq superstar2 timing tsip tripmate tnt ublox ubx" INPUT_DEVICES="libinput keyboard mouse" KERNEL="linux" L10N="es es-ES en en-US fr fr-FR" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="presenter-console presenter-minimizer" OFFICE_IMPLEMENTATION="libreoffice" PHP_TARGETS="php7-2" POSTGRES_TARGETS="postgres10 postgres11" PYTHON_SINGLE_TARGET="python3_6" PYTHON_TARGETS="python2_7 python3_6 python3_7 python3_8" RUBY_TARGETS="ruby24 ruby25" USERLAND="GNU" VIDEO_CARDS="fbdev vesa intel i965 nouveau nvidia" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account"
Unset:  CC, CPPFLAGS, CTARGET, CXX, INSTALL_MASK, LC_ALL, PORTAGE_BINHOST, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS
Comment 2 Matt Whitlock 2020-04-03 19:37:46 UTC
Created attachment 629520 [details, diff]
glibmm-enable-deprecated-api.patch

The build failure occurs because Inkscape uses deprecated glibmm APIs in <glibmm/timeval.h> but defines GLIBMM_DISABLE_DEPRECATED. The attached patch removes this preprocessor definition and allows Inkscape 0.92.4 to build using the deprecated glibmm APIs.

You can place the attached patch in /etc/portage/patches/media-gfx/inkscape-0.92.4/, and the ebuild will apply it automatically.
Comment 3 tt_1 2020-04-21 17:37:22 UTC
why are we even doing so much fuzz about stabilizing, if these things happen over and over again? thank you so much for the patch, Matt, this saved my life right now.
Comment 4 Alexey Korepanov 2020-04-23 10:17:59 UTC
It should be easy to add the patch to the ebuild. Why not?
Comment 5 Mart Raudsepp gentoo-dev 2020-04-23 15:20:23 UTC
One could try to call gnome2_disable_deprecation_warning instead in src_prepare phase, but not so important instead of a patch, as eautoreconf is already called anyways.
Comment 6 Larry the Git Cow gentoo-dev 2020-04-25 13:24:06 UTC
The bug has been closed via the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=ef6415751e610f63bdcbc60b133a84376d877785

commit ef6415751e610f63bdcbc60b133a84376d877785
Author:     Andreas K. Hüttel <dilfridge@gentoo.org>
AuthorDate: 2020-04-25 13:23:21 +0000
Commit:     Andreas K. Hüttel <dilfridge@gentoo.org>
CommitDate: 2020-04-25 13:23:50 +0000

    media-gfx/inkscape: Fix build against glibmm-2.62, bug 715394
    
    Patch by Matt Whitlock
    
    Closes: https://bugs.gentoo.org/715394
    Package-Manager: Portage-2.3.89, Repoman-2.3.20
    Signed-off-by: Andreas K. Hüttel <dilfridge@gentoo.org>

 media-gfx/inkscape/files/inkscape-0.92.4-glibmm-2.62.patch | 14 ++++++++++++++
 media-gfx/inkscape/inkscape-0.92.4-r2.ebuild               |  1 +
 media-gfx/inkscape/inkscape-0.92.4-r3.ebuild               |  1 +
 3 files changed, 16 insertions(+)